(
	
	global cleanerRoll
	try (destroyDialog cleanerRoll) catch()
	
	local theMaxFilesPath = ""
	local theMaxFiles = #()
	
	
	fn cleanOfLegacyAssets =
	(
		if (sceneConverter.GetMissingLegacyAssetsName()).count > 0 do
			(
				print "Found Legacy Assets: Cleaning"
				SceneConverter.ClearInvalidClassIDs()
				sceneConverter.RemoveMissingLegacyAssetsFromScene (sceneConverter.GetMissingLegacyAssetsName())
			)
	)
	
	
	
	
	rollout cleanerRoll "Legacy Assets Batch Cleaner" width:328 height:200
	(
		button 'btnMax' "Browse..." pos:[8,8] width:312 height:32 align:#left
		groupBox 'grp1' "Info:" pos:[8,48] width:312 height:72 align:#left
		label 'infoLbl' "" pos:[16,64] width:296 height:48 align:#left
		button 'btnGo' "Clean" pos:[8,128] width:312 height:40 align:#left enabled:false
		progressBar 'pb1' "ProgressBar" pos:[8,176] width:312 height:16 align:#left
		
		on btnMax pressed do
		(
			try 
			(
				theMaxFilesPath = getSavePath caption:"Please select a location to scan for Max Files to process"
				print theMaxFilesPath
			)
			catch ()
			
			if theMaxFilesPath != undefined then 
			(
				theMaxFiles =  getFiles (theMaxFilesPath + @"\*.max") recurse:true			
				infoLbl.text = ( theMaxFilesPath+@"\*.max" + " - (" + theMaxFiles.count as string + " files found)")
				btnMax.tooltip = infoLbl.text
				btnGo.enabled = true
			)
			else
			(
				infoLbl.text = ""
				if theMaxFiles.count == 0 do btnGo.enabled = false
			)
			pb1.value = 0
			pb1.color = Red	
		)

		on btnMax rightClick do
		(
			infoLbl.text = ""
			theMaxFilesPath = ""
			theMaxFiles = #()
			if theMatLibs.count == 0 do btnGo.enabled = false
			pb1.value = 0
			pb1.color = Red	
		)
		
		on btnGo pressed do
		(
			if theMaxFiles.count > 0 do
			(
				windows.SendMessage (windows.getMAXHWND()) 0x112 0xF020 0 --minimise Max
				SetQuietMode true
				i=0
				totCount = theMaxFiles.count as float
				for m in theMaxFiles do
				(
					windows.processPostedMessages()
					if keyboard.escPressed do exit
					try 
					(
					loadMaxFile m useFileUnits:true quiet:true allowPrompts:false
					cleanOfLegacyAssets()
					saveMaxFile m quiet:true
					)
					catch 
					(
						print ("Couldn't Find the File " + m )
					)
					i+=1
					percVal = (i/totCount)
					tempCol=pb1.color
					tempCol.hue = ceil (85. * percVal)
					pb1.color = tempCol
					pb1.value = percVal*100
				)
				SetQuietMode false
				windows.SendMessage (windows.getMAXHWND()) 0x112 0xF120 0 --restore Max
			)
		)
	)
	
	createDialog cleanerRoll
)